VERSION 5.00
Object = "{F9043C88-F6F2-101A-A3C9-08002B2F49FB}#1.2#0"; "COMDLG32.OCX"
Begin VB.UserControl RTFormat 
   ClientHeight    =   3120
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   3375
   ScaleHeight     =   3120
   ScaleWidth      =   3375
   ToolboxBitmap   =   "RTFormat.ctx":0000
   Begin VB.CommandButton cmdForecolor 
      Caption         =   "&Forecolor"
      Height          =   510
      Left            =   60
      Style           =   1  'Graphical
      TabIndex        =   4
      Top             =   1140
      Width           =   3240
   End
   Begin VB.CommandButton cmdBackcolor 
      Caption         =   "&Backcolor"
      Height          =   510
      Left            =   60
      Style           =   1  'Graphical
      TabIndex        =   3
      Top             =   600
      Width           =   3240
   End
   Begin VB.CommandButton cmdFontSettings 
      Caption         =   "&Font Settings"
      Height          =   510
      Left            =   60
      Style           =   1  'Graphical
      TabIndex        =   1
      Top             =   60
      Width           =   3240
   End
   Begin VB.PictureBox picPreview 
      Height          =   1380
      Left            =   75
      ScaleHeight     =   1320
      ScaleWidth      =   3150
      TabIndex        =   0
      Top             =   1680
      Width           =   3210
      Begin MSComDlg.CommonDialog cdlSelect 
         Left            =   2280
         Top             =   360
         _ExtentX        =   847
         _ExtentY        =   847
         _Version        =   393216
         CancelError     =   -1  'True
      End
      Begin VB.Label lblPreviewText 
         Alignment       =   2  'Center
         BackStyle       =   0  'Transparent
         Caption         =   "Label1"
         Height          =   1215
         Left            =   60
         TabIndex        =   2
         Top             =   60
         Width           =   3060
      End
   End
End
Attribute VB_Name = "RTFormat"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit
'Event Declarations:
Public Event BackcolorChanged(NewColor As OLE_COLOR)
Attribute BackcolorChanged.VB_Description = "Fires when the end-user changes the RTFBackcolor property by clicking on the 'Backcolor' button of the ActiveX contro"
Public Event ForecolorChanged(NewColor As OLE_COLOR)
Attribute ForecolorChanged.VB_Description = "Fires when the end-user changes the RTFForecolor property by clicking on the 'Forecolor' button of the ActiveX control"
Public Event FontChanged(NewFont As StdFont)
Attribute FontChanged.VB_Description = "Fires when the end-user changes the RTFFontr property by clicking on the 'Font Settings' button of the ActiveX contro"

'Default values of member variables
Private Const defPreviewText = "This is some preview text."
Private Const defEnabled = True

'Enabled property. It maps to the cmdFontSettings.Enabled,cmdBackcolor.Enabled,
'cmdForeColor enabled and Usercontrol.Enabled properties
Public Property Get Enabled() As Boolean
Attribute Enabled.VB_ProcData.VB_Invoke_Property = ";Behavior"
Attribute Enabled.VB_UserMemId = -514
   Enabled = UserControl.Enabled
End Property

Public Property Let Enabled(ByVal vNewValue As Boolean)
   UserControl.Enabled = vNewValue
   cmdFontSettings.Enabled = vNewValue
   cmdBackcolor.Enabled = vNewValue
   cmdForecolor.Enabled = vNewValue
End Property

'PreviewText property. It maps to lblPreviewText.Caption
Public Property Get PreviewText() As String
   PreviewText = lblPreviewText.Caption
End Property

Public Property Let PreviewText(ByVal vNewValue As String)
   'preview text can't be a null string
   If vNewValue = "" Then Exit Property
   lblPreviewText.Caption = vNewValue
   PropertyChanged "PreviewText"
End Property

'Backcolor property. It maps to the cmdFontSettings.Backcolor,cmdBackcolor.Backcolor,
'cmdForecolor.Backcolor and Usercontrol.Backcolor properties
Public Property Get BackColor() As OLE_COLOR
   BackColor = cmdFontSettings.BackColor
End Property

Public Property Let BackColor(ByVal New_BackColor As OLE_COLOR)
Attribute BackColor.VB_Description = "Returns/sets the background color used to display text and graphics in an object."
Attribute BackColor.VB_ProcData.VB_Invoke_PropertyPut = ";Appearance"
   cmdFontSettings.BackColor = New_BackColor
   cmdBackcolor.BackColor = New_BackColor
   cmdForecolor.BackColor = New_BackColor
   UserControl.BackColor = New_BackColor
   PropertyChanged "BackColor"
End Property

'BorderStyle property. It maps to the UserControl.Borderstyle property
Public Property Get BorderStyle() As mscomctllib.BorderStyleConstants
Attribute BorderStyle.VB_Description = "Returns/sets the border style for an object."
Attribute BorderStyle.VB_ProcData.VB_Invoke_Property = ";Appearance"
   BorderStyle = UserControl.BorderStyle
End Property

Public Property Let BorderStyle(ByVal New_BorderStyle As mscomctllib.BorderStyleConstants)
   UserControl.BorderStyle() = New_BorderStyle
   PropertyChanged "BorderStyle"
End Property

'Font property. It maps to the cmdFontSettings.Font,cmdBackColor.Font and
'cmdForeColor.Font properties
Public Property Get Font() As StdFont
Attribute Font.VB_Description = "Returns a Font object."
Attribute Font.VB_ProcData.VB_Invoke_Property = ";Font"
Attribute Font.VB_UserMemId = -512
   Set Font = cmdFontSettings.Font
End Property

Public Property Set Font(ByVal New_Font As StdFont)
   Set cmdFontSettings.Font = New_Font
   Set cmdBackcolor.Font = New_Font
   Set cmdForecolor.Font = New_Font
   PropertyChanged "Font"
End Property

'RTFBackcolor property. It maps to the picPreview.Backcolor property
Public Property Get RTFBackcolor() As OLE_COLOR
Attribute RTFBackcolor.VB_Description = "Returns/sets the background color used to display text and graphics in an object."
Attribute RTFBackcolor.VB_ProcData.VB_Invoke_Property = ";Misc"
   RTFBackcolor = picPreview.BackColor
End Property

Public Property Let RTFBackcolor(ByVal New_RTFBackcolor As OLE_COLOR)
   picPreview.BackColor() = New_RTFBackcolor
   PropertyChanged "RTFBackcolor"
End Property

'RTFForecolor property. It maps to the lblPreviewText.Forecolor property
Public Property Get RTFForecolor() As OLE_COLOR
Attribute RTFForecolor.VB_Description = "Returns/sets the foreground color used to display text and graphics in an object."
Attribute RTFForecolor.VB_ProcData.VB_Invoke_Property = ";Misc"
   RTFForecolor = lblPreviewText.ForeColor
End Property

Public Property Let RTFForecolor(ByVal New_RTFForecolor As OLE_COLOR)
   lblPreviewText.ForeColor() = New_RTFForecolor
   PropertyChanged "RTFForecolor"
End Property

'RTFFont property. It maps to the lblPreviewText.Font property
Public Property Get RTFFont() As StdFont
Attribute RTFFont.VB_Description = "Returns a Font object."
Attribute RTFFont.VB_ProcData.VB_Invoke_Property = ";Misc"
   Set RTFFont = lblPreviewText.Font
End Property

Public Property Set RTFFont(ByVal New_RTFFont As StdFont)
   Set lblPreviewText.Font = New_RTFFont
   PropertyChanged "RTFFont"
End Property

'Select a new value for the RTFBackcolor property
Private Sub cmdBackcolor_Click()

   On Error Resume Next
   
   With cdlSelect
      
      'apply current attributes to font dialog
      .Color = RTFBackcolor
      .ShowColor
   
   End With
   
   If Err.Number = 0 Then
      RTFBackcolor = cdlSelect.Color
      'raise the BackcolorChanged event for the developer
      RaiseEvent BackcolorChanged(RTFBackcolor)
   End If

End Sub

'Select a new value for the RTFFont property
Private Sub cmdFontSettings_Click()

   On Error Resume Next
   
   With cdlSelect
      .Flags = cdlCFBoth + cdlCFEffects + cdlCFForceFontExist
  

      'apply current attributes to font dialog
      .FontBold = lblPreviewText.FontBold
      .FontItalic = lblPreviewText.FontItalic
      .FontName = lblPreviewText.FontName
      .FontSize = lblPreviewText.FontSize
      .FontStrikethru = lblPreviewText.FontStrikethru
      .FontUnderline = lblPreviewText.FontUnderline

      .ShowFont
   End With
   
   If Err.Number = 0 Then
      With lblPreviewText.Font
         .Bold = cdlSelect.FontBold
         .Italic = cdlSelect.FontItalic
         .Name = cdlSelect.FontName
         .Size = cdlSelect.FontSize
         .Strikethrough = cdlSelect.FontStrikethru
         .Underline = cdlSelect.FontUnderline
      End With
      
      'The forecolor of the text can also be set with the Font common dialog
      lblPreviewText.ForeColor = cdlSelect.Color
      
      'raise the FontChanged event for the developer
      RaiseEvent FontChanged(RTFFont)
      
      'raise the ForecolorChanged event for the developer
      RaiseEvent ForecolorChanged(lblPreviewText.ForeColor)
      
   End If

End Sub

'Select a new value for the RTFForecolor property
Private Sub cmdForecolor_Click()

   On Error Resume Next
   
   With cdlSelect
      
      'apply current attributes to font dialog
      .Color = RTFBackcolor
      .ShowColor
   
   End With
   
   If Err.Number = 0 Then
      RTFForecolor = cdlSelect.Color
      'raise the ForecolorChanged event for the developer
      RaiseEvent ForecolorChanged(RTFForecolor)
   End If
   
End Sub

Private Sub UserControl_InitProperties()

   PreviewText = defPreviewText
   Enabled = defEnabled

End Sub

'Load property values from storage
Private Sub UserControl_ReadProperties(PropBag As PropertyBag)

   cmdFontSettings.BackColor = PropBag.ReadProperty("BackColor", &H8000000F)
   cmdBackcolor.BackColor = PropBag.ReadProperty("BackColor", &H8000000F)
   cmdForecolor.BackColor = PropBag.ReadProperty("BackColor", &H8000000F)
   UserControl.BackColor = PropBag.ReadProperty("BackColor", &H8000000F)
   
   Set cmdFontSettings.Font = PropBag.ReadProperty("Font", Ambient.Font)
   Set cmdBackcolor.Font = PropBag.ReadProperty("Font", Ambient.Font)
   Set cmdForecolor.Font = PropBag.ReadProperty("Font", Ambient.Font)
   
   UserControl.BorderStyle = PropBag.ReadProperty("BorderStyle", 0)
   picPreview.BackColor = PropBag.ReadProperty("RTFBackcolor", &H8000000F)
   lblPreviewText.ForeColor = PropBag.ReadProperty("RTFForecolor", &H80000012)
   Set lblPreviewText.Font = PropBag.ReadProperty("RTFFont", Ambient.Font)
   lblPreviewText.Caption = PropBag.ReadProperty("PreviewText", defPreviewText)
   
   Enabled = PropBag.ReadProperty("Enabled", defEnabled)
   
   
   
End Sub

'Write property values to storage
Private Sub UserControl_WriteProperties(PropBag As PropertyBag)

   Call PropBag.WriteProperty("BackColor", cmdFontSettings.BackColor, &H8000000F)
   Call PropBag.WriteProperty("BorderStyle", UserControl.BorderStyle, 0)
   Call PropBag.WriteProperty("Font", cmdFontSettings.Font, Ambient.Font)
   Call PropBag.WriteProperty("RTFBackcolor", picPreview.BackColor, &H8000000F)
   Call PropBag.WriteProperty("RTFForecolor", lblPreviewText.ForeColor, &H80000012)
   Call PropBag.WriteProperty("RTFFont", lblPreviewText.Font, Ambient.Font)
   Call PropBag.WriteProperty("PreviewText", lblPreviewText.Caption, defPreviewText)
   Call PropBag.WriteProperty("Enabled", UserControl.Enabled, defEnabled)

End Sub

Private Sub UserControl_Resize()
   'The control has a persistent width and height
   UserControl.Width = 3375
   UserControl.Height = 3120
End Sub


